﻿Type=StaticCode
Version=2
ModulesStructureVersion=1
B4R=true
@EndOfDesignText@

'#Region Project Attributes
'	#IgnoreWarnings: 12
'	#StackBufferSize: 3000
'#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.
	Private client As WiFiSocket
	Private serverName() As Byte = "fcm.googleapis.com"
	
	Private const DEFAULT_TITLE() As Byte = "This is default title"
	Private const DEFAULT_MESSAGE() As Byte = "Hello from ESP8266!"
	
	'	Private Const FIELD_COUNT As Byte = 30

	Public  FCM_DEBUG As Boolean = True   ' <<<<<<<<---------- UNCOMMENT THIS TO SHOW SERIAL DEBUG
	Private bc As ByteConverter
	Private API_KEY() As Byte
	
	Type KeyValuePair(key() As Byte, val() As Byte)
	Public field(30) As KeyValuePair      ' <<<<<<<<---------- INCREASE THIS NUMBER TO USE MORE CUSTOM FIELDS
	Private EOL() As Byte = Array As Byte(13, 10)
	Private Success As Boolean
End Sub

Sub Initialize(ApiKey() As Byte) 'ignore
	bc.ArrayCopy(ApiKey, API_KEY)
	Log("Initialize(", API_KEY, ")")
	ResetFields
End Sub

Sub SendMessage(tokens() As String, tokensLen As UInt, From() As Byte, Title() As Byte, Message() As Byte) As Boolean 'ignore
	Log("*** SendMessage ***")
	Log("tokens(0): ", tokens(0))
	Log("tokensLen: ", tokensLen) 
	Log("From: ", From)
	Log("Tite: ", Title)
	Log("Message: ", Message)
	
	ResetFields
	Dim isTopic As Boolean = (tokens(0).length <= 64)
	
'	Dim tokensLen As UInt = tokens.Length
	
'	bc.ArrayCopy("fromme", field(0).key)
'	bc.ArrayCopy(From, field(0).val)
	field(0).key = "fromme"
	field(0).val = From
  
	If(tokensLen = 1) Then
		field(1).Key = "to"
    
		If isTopic Then
			field(1).val = JoinBytes(Array("/topics/", tokens(0)))
		Else
			field(1).val = tokens(0)
		End If
	Else
		If isTopic Then
			Dim tmp As String = """"    ' DA CONTROLLARE
			For i = 0 To  tokensLen-1
				JoinBytes(Array(tmp, "'", tokens(i), "'", " in topics"))
				If(i < (tokensLen-1)) Then
					JoinBytes(Array(tmp, " || "))
				Else
					JoinBytes(Array(tmp, ""","))
				End If
			Next
			field(1).key = "condition"
			field(1).val = tmp
		Else
			' Do NOTHING For NOW
		End If
	End If
  
	field(2).key = "title"
	field(2).val = Title
	field(3).key = "message"
	field(3).val = Message
  
	ShowAllFields                      ' DEBUG
'	Log("Chiamo SendMessage2(", tokens(0), ", ", tokensLen, ")")
	
	Return SendMessage2(tokens, tokensLen)
End Sub

Sub ShowAllFields()
	For i = 0 To field.Length-1                        ' DEBUG
		Log("FIELD[", i, "]  key:  ", field(i).key)
		Log("FIELD[", i, "]  val:  ", field(i).val)
	Next
End Sub

Sub SendMessage2(tokens() As String, tokensLen As UInt) As Boolean
	Log("*** SendMessage2 ***")
	Log("tokens(0): ", tokens(0))
	Log("tokensLen: ", tokensLen)

'	Dim Body1() = "", Body2() = "", Body3() = "", Body4() = "", Params() = "", Data() = "", Regist() = "" As Byte
'	Dim Body1(100) = "", Body2(100) = "", Body3(100) = "", Body4(100) = "", Params(100) = "", Data(100) = "", Regist(100) = "" As Byte
	
	Success = False
	Dim isTopic As Boolean = (tokens(0).Length <= 64)

	'unsigned int len = (SizeOf(tokens) / SizeOf(String));
	'Serial.print("LEN: ");
	'Serial.println(len);
  
	Dim size As UInt = field.Length
	Log("Field Size: ", size)
	
	'	If client.Connected Then client.Close ' Just to be sure

	'//////////
	If isTopic Then
		If(tokensLen = 1) Then
			field(size-1).key = "to"
			field(size-1).val = JoinBytes(Array("/topics/", tokens(0)))
		Else
			Dim tmp As String = """"
			For i = 0 To tokensLen-1
				JoinBytes(Array(tmp, "'", tokens(i), "'", " in topics"))
				If(i <(tokensLen-1)) Then
					JoinBytes(Array(tmp, " || "))
				Else
					JoinBytes(Array(tmp, """"))
				End If
			Next
			field(size-1).key = "condition"
			field(size-1).val = tmp
		End If
	Else
		Log("IS NOT A TOPIC")	      ' DEBUG
	End If
	'/////////

'	ShowAllFields        ' DEBUG
	
	'////////// SOLO TEST //////////
	''''''	Connect(0)
	'	Log("Connected to server")
	'	Log(" ")
	'	astream.Initialize(client.Stream, "Astream_NewData", "Astream_Error")
	'///////////////////////////////
	
	'	HttpJob.Initialize("mainJob")
	'	HttpJob.AddHeader("User-Agent", "Arduino")
	'	HttpJob.AddHeader("Content-Type", "application/json")
	'	HttpJob.AddHeader("Authorization", JoinBytes(Array("key=".GetBytes, API_KEY)))
	'	Log("stack: ", StackBufferUsage, ", buffer size:", raf.CurrentPosition)
	'	HttpJob.Post("https://fcm.googleapis.com/fcm/send", bc.SubString2(buffer, 0, raf.CurrentPosition))


	'	If (client.ConnectHost(bc.StringFromBytes(serverName), 80)) Then
	'  If client.Connected Then
	'		If FCM_DEBUG Then Log("Connected to ", serverName)

	'''''		' make http POST request
	'''''		Dim Header() As Byte = ""
	'''''		Header = JoinBytes(Array(Header, "POST /fcm/send HTTP/1.1", CRLF))
	'''''		Header = JoinBytes(Array(Header, "Host: ", serverName, CRLF))
	'''''		Header = JoinBytes(Array(Header, "User-Agent: Arduino", CRLF))
	'''''		Header = JoinBytes(Array(Header, "Content-Type: application/json", CRLF))
	'''''		Header = JoinBytes(Array(Header, "Authorization: key=", API_KEY, CRLF))
	'''''		Header = JoinBytes(Array(Header, "Content-length: "))  ' has To be exactly the number of characters (bytes) in the POST Body

	'	Dim Header As String = JoinStrings(Array As String("POST /fcm/send HTTP/1.1", CRLF , _
	'		                                                 "Host: fcm.googleapis.com", CRLF , _
	'																								     "Authorization: key=", rApiKey, CRLF , _
	'																								     "Content-Type: application/json", CRLF ))
	
	Log(" ")
	Dim fieldCount As Int = 0
	Dim k(), v() As Byte

	For i = 0 To size-1 ' find fields count
		'''''		field(i).key.toLowerCase()
		ToLowerCase(field(i).key)
		k = field(i).key
		v = field(i).val
'		Log("key: ", k, "   len: ", k.Length)
'		Log("val: ", v, "   len: ", v.Length)
		If (k.Length > 0 And v.Length > 0) Then
			Log("[Found field]    Key: ", k, TAB, "Value: ", v)
			fieldCount = fieldCount + 1
		End If
	Next
	
	If FCM_DEBUG Then		
		Log(" ") : Log("Total Used Fields: ", fieldCount) : Log(" ")
	End If
	
	Dim Params() As Byte = ""     ' I tried to remove = ""
	ShowAllFields ' DEBUG         '******* HERE WE HAVE A MISSING KEY field(0) SEEM TO BE RELATIVE TO PREVOUUS LINE *******
	
	For i = 0 To size-1  ' PREDATA
		k = field(i).key
		v = field(i).val
		If (k.Length > 0 And v.Length > 0) Then
			If (k = "collapse_key") Then
				'''''	 Params = String("   \"" + key + "\": \"" + val + "\",\n")
				Params = JoinBytes(Array("   """, k, """: """, v, """,", EOL))
			End If
			If (k = "time_to_live" Or k = "delay_while_idle") Then
				'''''	 Params = String("   \"" + key + "\": " + val + ",\n");
				Params = JoinBytes(Array("   """, k, """: ", v, ",", EOL))
			End If
			If (k = "condition" And isTopic) Then
				'''''	 Params = String("   \"" + key + "\": " + val + ",\n");
				Params = JoinBytes(Array("   """, k, """: ", v, ",", EOL))
			End If
			If (k = "to" And isTopic) Then
				'''''	 Params = String("   \"" + key + "\": \"" + val + "\",\n");
				Params = JoinBytes(Array("   """, k, """: """, v, """,", EOL))
			End If
		End If
	Next
   
	Log(" ")
	If Params.Length > 0 Then 
		Log("PARAMS STRING: ", Params)   ' AS DEBUG
	Else
		Log("NO PARAMS")
	End If
	
Log("POINT 1")
	ShowAllFields

	'''''	Body += Params;
	Dim Body1() As Byte = JoinBytes(Array("{".GetBytes, EOL, Params))  ' Main Body, add params to body (body + params)
	Dim Data() As Byte = ""

	'//////////
Log("POINT 2")
ShowAllFields
	'''''	Data = "   \"data\": {"; Data += "\n"; // Data
	Data = JoinBytes(Array("   ""data"": {".GetBytes, EOL))
	Dim title() As Byte = ""
	Dim msg() As Byte = ""
Log("POINT 3")
ShowAllFields
	For i = 0 To size-1
		'''''		field(i).key.toLowerCase()
		ToLowerCase(field(i).key)
		k = field(i).key
		v = field(i).val
		Log("[", i, "]   K: ", k, "  V: ", v)
		If (k.Length > 0 And v.Length > 0) Then
			'''''	If (key != "collapse_key" && key != "delay_while_idle" && key != "time_to_live" && key != "condition" && key != "to") {
			If (k <> "collapse_key" And k <> "delay_while_idle" And k <> "time_to_live" And k <> "condition" And k <> "to") Then
				'	Data += "      \""; Data += key; Data += "\": \""; Data += val; Data += "\","; Data += "\n";
				Data = JoinBytes(Array(Data, "      """.GetBytes, k, """: """.GetBytes, v, """,".GetBytes, EOL))
				If (k = "title") Then title = v
				If (k = "message" Or k = "data") Then msg = v
				Log("FINE (IF)")
			End If
		End If
	Next
	
	Log("POINT 5")
	If (title = "") Then
		Data = JoinBytes(Array(Data, "      ""title"": """, DEFAULT_TITLE, """", EOL))
		title = DEFAULT_TITLE
	End If
	Log("POINT 6")
	If (msg = "") Then
		Data = JoinBytes(Array(Data, "      ""message"": """, DEFAULT_MESSAGE, """", EOL))
		msg = DEFAULT_MESSAGE
	End If
	
	Log("POINT 7")
	If (msg <> DEFAULT_MESSAGE) Then
		'''''		Data.remove(Data.lastIndexOf(","));
		Data = bc.SubString2(Data, 0, bc.LastIndexOf(Data,","))
		Data = JoinBytes(Array(Data, EOL))
		If Not(isTopic) Then
			Data = JoinBytes(Array(Data, "   },", EOL))
		Else
			Data = JoinBytes(Array(Data, "   }", EOL))
		End If
	Else      
		If Not(isTopic) Then
			Data = JoinBytes(Array(Data, "   },", EOL))
		Else
			Data = JoinBytes(Array(Data, "   }", EOL))
		End If
	End If

	Log(" ")
	Log("DATA STRING: ")
	Log(Data)

	'''''	Body += Data;
	Dim Body2() As Byte = JoinBytes(Array(Body1, Data))  'add data to body (body + params + data)
	Dim Regist() As Byte = ""
Log("POINT 8")
	If Not(isTopic) Then
		'	Regist += F("   \"registration_ids\": ["); ' registration string
		Regist = JoinBytes(Array("   ""registration_ids"": [")) ' registration string
		For i = 0 To tokensLen-1   ' Max 1000
			'			If (tokens(i) <> "" And tokens(i) <> Null) Then
			If (tokens(i) <> "") Then
	  
				If (i = 0) Then
					Regist = JoinBytes(Array(Regist, """", tokens(i)))
				Else
					Regist = JoinBytes(Array(Regist, "                        """, tokens(i)))
				End If
	  
				If (i < (tokensLen-1)) Then
					Regist = JoinBytes(Array(Regist, """", EOL))
				Else
					Regist = JoinBytes(Array(Regist, """]", EOL))
				End If
	  
			End If
		Next
	End If
	
'	Dim Body3() As Byte = ""
	Dim Body3() As Byte = JoinBytes(Array(Body2, Regist, "}"))  ' end of Body request, add register to body (body + params + data + register)

	'///////////
	Dim datalen As Int = Body3.Length     ' calculate content-length
	'	Header = JoinBytes(Array(Header, datalen, EOL, "Connection: close", EOL, EOL, Body))

	If FCM_DEBUG Then
		Log(" ")
		Log("******************************************************************")
		Log(" ")
		Log("Connecting to fcm.googleapis.com")
	End If

	If FCM_DEBUG Then
		Log(" ")
		Log("REQUEST BODY: ")
		Log(" ")
		Log(Body3)
		Log(" ")
		Log(" ")
		Log("Sending request...")
	End If
    
	'		client.Stream.WriteBytes(Header, 0, Header.Length)  ' Send request
	HttpJob.Initialize("mainJob")
	HttpJob.AddHeader("User-Agent", "Arduino")
	HttpJob.AddHeader("Content-Type", "application/json")
	HttpJob.AddHeader("Authorization", JoinBytes(Array("key=".GetBytes, API_KEY)))
	Log("stack: ", StackBufferUsage, ", DataLen:", datalen)
	HttpJob.Post("https://fcm.googleapis.com/fcm/send", bc.SubString2(Body3, 0, Body3.Length))
		
	If FCM_DEBUG Then
		Log("Request sent")
		Log(" ")
		Log("STATISTICS:")
		Log("Title: ", title)
		Log("Message: ", msg)
		Log("Message length: ", msg.Length, " bytes")
		Log("Body length: ", datalen, " bytes")
		Log(" ")

		For i = 0 To tokensLen-1
			Log("Token[", i, "] length: ", tokens(i).Length, " bytes")
		Next
	End If
     
'		' Get response from FCM server
'		Dim timeout As UInt = 0
'		Do While Not(client.Stream.BytesAvailable > 0)
'			Delay(1)
'			timeout = timeout + 1
'			If (timeout > 5000) Then
'				success = False
'				If FCM_DEBUG Then Log("Response timeout", CRLF)
'				client.Close
'				ShowSuccess(success)
'			End If
'		Loop
'
'		Dim inString() As Byte = ""
'		Do While (client.Stream.BytesAvailable > 0)
'			Dim inChar() As Byte
'			client.Stream.ReadBytes(inChar, 0, 1)
'			'''''			inString += inChar
'			inString = JoinBytes(Array(inString,inChar))
'		Loop
'
'		If FCM_DEBUG Then
'			Log(" ")
'			Log("Received response from FCM server: ")
'			Log(" ")
'			Log(inString)
'		End If
'    
'		If (bc.IndexOf(inString, "Error") >= 0) Or (bc.IndexOf(inString,"error") >= 0) Then
'			If FCM_DEBUG Then
'				Log(" ")
'				Log("FCM server returned one or more errors")  ' Error
'				Log(" ")
'			End If
'			success = False
'			client.Close
'			ShowSuccess(success)
'		End If
'
'		If (inString = "") Then
'			If FCM_DEBUG Then
'				Log(" ")
'				Log("FCM server returned void response")
'				Log(" ")
'			End If
'			success = False
'			client.Close
'			ShowSuccess(success)
'		End If
'
'		'''''		If (inString.indexOf(F("200 OK")) >= 0 && inString.indexOf(F("\"failure\":0")) >= 0 || inString.indexOf(F("\"message_id\"")) >= 0) {
'		If (bc.indexOf(inString, "200 OK") >= 0 And bc.indexOf(inString, """failure"":0") >= 0 Or bc.indexOf(inString,"""message_id""") >= 0) Then
'			success = True
'		Else
'			If FCM_DEBUG Then
'				Log("FCM server returned error") ' Error
'				Log(" ")
'			End If
'			success = False
'		End If
'	Else
'		If FCM_DEBUG Then
'			Log("Connection to FCM server failed!")
'			Log(" ")
'		End If
'		success = False
'	End If
'
'	ShowSuccess(success)
	
	Delay(50)
'	Success = True  ' <<<<<<<<< SOLO PER DEBUG (DA ELIMINARE)
	Return Success
End Sub

'Sub Connect(unused As Byte)
'	If client.ConnectHost("fcm.googleapis.com", 80) = False Then
'		Log("Trying to connect...")
''		CallSubPlus("Connect", 1000, 0)
'		Delay(1000)
'		Connect(0)
'		Return
'	End If
'	Log("Connected to server")
'	Log(" ")
'	'	astream.Initialize(socket.Stream, "Astream_NewData", "Astream_Error")
'End Sub
	
Private Sub ShowSuccess(succ As Boolean)
	If (succ) Then
		If FCM_DEBUG Then
			Log(" ")
			Log("Message sent successfully!")
			Log(" ")
		End If
	End If
End Sub

Sub ResetFields()
	For i = 0 To field.Length-1
'		Log("Reset field ", i)
		field(i).key = ""
'		Log("key: ", field(i).Key)
		field(i).val = ""
'		Log("val: ", field(i).val)
'		Delay(1)
	Next
End Sub

'Sub ToUpperCase(s() As Byte)
'	For i = 0 To s.Length - 1
'		If s(i) >= 97 And s(i) <= 122 Then
'			s(i) = s(i) - 32
'		End If
'	Next
'End Sub

Sub ToLowerCase(s() As Byte)
	For i = 0 To s.Length - 1
		If s(i) >= 65 And s(i) <= 90 Then
			s(i) = s(i) + 32
		End If
	Next
End Sub

Sub JobDone (Job As JobResult)
	Log(" ")
	Log("*******************************")
	Log("JobName: ", Job.JobName)

	If Job.Success Then
		If FCM_DEBUG Then Log("Connected to ", serverName)
		
		'		Dim bc As ByteConverter
		'		Log("Response: ", bc.SubString2(Job.Response, 0, Min(200, Job.Response.Length))) 'truncate to 200 characters
		'		If Job.JobName = "Example" Then
		'			'send another request
		'			'This time it is a POST request and we set the Content-Type header
		'			HttpJob.Initialize("Example2")
		'			'add headers before calling Post or Download (this is different than the standard HttpUtils2).
		'			HttpJob.AddHeader("Content-Type", "application/x-www-form-urlencoded")
		'			HttpJob.Post("http://www.b4x.com/print.php?key1=val1", "PostKey1=Postval2&abc=def")
		'		End If

		' Get response from FCM server

		ShowSuccess(Job.Success)

		Dim inString() As Byte = Job.Response
		
		If FCM_DEBUG Then
			Log(" ")
			Log("Received response from FCM server: ")
			Log(" ")
			Log(inString)
		End If
	    
		If (bc.IndexOf(inString, "Error") >= 0) Or (bc.IndexOf(inString,"error") >= 0) Then
			If FCM_DEBUG Then
				Log(" ")
				Log("FCM server returned one or more errors")  ' Error
				Log(" ")
			End If
			Success = False
			ShowSuccess(Success)
		End If

		If (inString = "") Then
			If FCM_DEBUG Then
				Log(" ")
				Log("FCM server returned void response")
				Log(" ")
			End If
			Success = False
			client.Close
			ShowSuccess(Success)
		End If

		'''''		If (inString.indexOf(F("200 OK")) >= 0 && inString.indexOf(F("\"failure\":0")) >= 0 || inString.indexOf(F("\"message_id\"")) >= 0) {
		If (bc.indexOf(inString, "200 OK") >= 0 And bc.indexOf(inString, """failure"":0") >= 0 Or bc.indexOf(inString,"""message_id""") >= 0) Then
			Success = True
		Else
			If FCM_DEBUG Then
				Log("FCM server returned error") ' Error
				Log(" ")
			End If
			Success = False
		End If
	Else
		If FCM_DEBUG Then
			Log("Connection to FCM server failed!")
			Log(" ")
		End If
		Success = False
		Log("ErrorMessage: ", Job.ErrorMessage)
		Log("Status: ", Job.Status)
		Log(Job.Response)
	End If

	ShowSuccess(Success)

End Sub

Sub Astream_NewData (Buffer() As Byte)
	Log("Astream_NewData")
	Log(Buffer)
End Sub

Sub Astream_Error
	Log("Disconnected")
End Sub
